/* @(#)60  1.11  include/m6db.h, m6co_headers, sco_3.0, 301FCS 2/2/95 11:19:30, SecureWare, Inc. */

/*
 * Copyright (c) 1990-1994 SecureWare, Inc.  All rights reserved.
 */

/*
 * MaxSix 2.1, July 27, 1992
 * Copyright 1990-1992, SecureWare, Inc.
 */

#ifndef __M6DB__
#define __M6DB__

#include <sys/secdefines.h>

#if SEC_MSIX_INET

#include <prot.h>
#include <sys/sctnaccred.h>

#if	SEC_MSIX_RCAS_OSI
#include <sys/m6address.h>
#endif	/* SEC_MSIX_RCAS_OSI */

#define M6_DEVICE		"/dev/m6_0"
#define M6_CLIENT		"/dev/m6_1"
#define M6_DBASE_FILE		"/tcb/files/M6DB"
#define M6_IDB			"/tcb/files/M6IDB"
#define M6_IDB_TEMPLATE		"/tcb/files/templates/m6/M6IDB"
#define M6_RHDB			"/tcb/files/M6RHDB"
#define M6_CONFDB		"/tcb/files/M6CONFDB"
#define M6_DOMAINS		"/tcb/files/M6DOMAINS"
#define M6_HOSTGRP		"/tcb/files/M6HOSTGRP"
#define M6_BINMAP		"/tcb/files/M6BINMAP"
#define M6_MAPPINGS		"/tcb/files/M6MAPPINGS"
#define M6_HOSTDB		"/etc/hosts"
#define M6_OSIDB		"/etc/hosts.osi"
#define MKDB_FILE		"/tcb/bin/m6mkdb"
#define MKDB_BASE		"/tcb/bin/"
#define ETC_GROUP		"/etc/group"
#define ETC_PASSWD		"/etc/passwd"

#define M6_WILDCARD_ADDR	0x0

#define M6RDS_MAX_TIMEOUT 120
#define M6RDS_DEF_TIMEOUT 3
#define M6RDS_MAX_RETRIES 10
#define M6RDS_DEF_RETRIES 1
#define M6D_MAX_SIZE 8192
#define M6D_DEF_SIZE 4096
#define M6D_MAX_FULL 100
#define M6D_DEF_FULL 80

/* structure used whenever we want to represent a list of addresses */

struct addrlist {
	long count;
	ulong *addr;
};


#if	SEC_MSIX_RCAS_OSI
struct m6addrlist {
	long count;
	struct m6sockaddr *addr;
};
#endif	/* SEC_MSIX_RCAS_OSI */
 
/* structure used by the M6CONFDB routines... */

struct m6config {
        long vendor;
        long rh_cache_const;
        long max_rh_cache_size;
        long loc_cache_size;
        long rh_db_size;
        long sr_db_size;
        long max_restart_Q;
        long bad_host_size;
        long rds_timeout;
        long rds_retries;
	long m6d_size;
	long m6d_full;
#if SEC_MAC
	long dom_sl;
#endif
#if SEC_ILB
	long dom_ilb;
#endif
#if SEC_NCAV
	long dom_ncav;
#endif
	long dom_privs;
	long dom_uids;
	long dom_gids;
#if SEC_ACL
	long dom_acls;
#endif
	long aud_bufcount;
	long aud_bufsize;
	long tok_server;
	long tok_backup;
	struct addrlist tok_redirect;
	long aud_server;
	long aud_backup;
	struct addrlist aud_redirect;
#if SEC_MAC
        mand_ir_t *aud_level;
#endif
};

/* structure used by the M6DOMAINS routines */

#define MAX_DOMAIN_NAME	48

struct m6domain {
	short	type;
	u_short	flags;
	u_long	number;
	u_long	extra_stuff;
	u_long	aliases;
#if SEC_MAC
#ifdef __cplusplus
	char	**class_ir;
#else
	char	**class;
#endif
	char	**cat;
#endif
#if SEC_ILB
	char	**mark;
#endif
#if SEC_NCAV
	char	**ncav;
#endif
	char	**privs;
	char	**uids;
	char	**gids;
#if SEC_ACL
	char	**acl_types;
#endif
	char	**extra1;
	char	**extra2;
	char	name [MAX_DOMAIN_NAME];
	u_long	weighting_factor;
};

/* structure used by the M6HOSTGRP routines */

#define MAX_GROUP_NAME	64

struct m6hostgrp {
	char	name [MAX_GROUP_NAME];
	char	**hosts;
};

/* structures necessary for the M6IDB and M6RHDB routines */

#if SEC_MAC
typedef struct {
        mand_ir_t *minv;          /* minimum sensitivity level */
        mand_ir_t *max;          /* maximum sensitivity level */
} sl_accred;
#endif

#if SEC_NCAV
typedef struct {
        ncav_ir_t *minv;        /* minimum national caveat   */
        ncav_ir_t *max;        /* maximum national caveat   */
} nc_accred;
#endif

#if SEC_INTEG_LABEL
typedef struct {
        long        notyet;
} in_accred;
#endif

typedef struct {
#if SEC_MAC
        u_short    sl_elements;     /* no. of sens. level ranges */
        sl_accred  sl [SLSZ];       /* ptr. to array of sens level prs. */
#endif
#if SEC_NCAV
        u_short    ncav_elements;   /* no. of nat. caveat ranges */
        nc_accred  ncav [NCAVSZ];   /* ptr. to array of nat cav.   prs. */
#endif
#if SEC_INTEG_LABEL
        u_short    integ_elements;  /* no. of integ. ranges      */
        in_accred  integ [INSZ];    /* ptr. to array of integ.   prs.   */
#endif
} m6_accred;

typedef struct {
        u_short   attr_mask;            /* mask of mandatory attributes */
        u_short   def_attr_mask;	/* mask of defaults specified  */
        u_long    flags;                /* flags                       */
        m6_accred accred;               /* accreditation of interface  */
#if SEC_MAC
        mand_ir_t *default_sl;          /* default sensitivity label   */
#endif
#if SEC_NCAV
        ncav_ir_t *default_ncav;        /* default national caveat     */
#endif
#if SEC_ILB
        ilb_ir_t  *default_ilb;         /* default information label   */
#endif
        mask_t    default_privs[SEC_SPRIVVEC_SIZE];  
				        /* default privileges */
        uid_t     default_luid;         /* default login user id      */
        uid_t     default_uid;          /* default user id            */
        gid_t     default_gid;          /* default group id           */
        gid_t     default_no_grps;      /* default no. of suppl. groups */
#if SEC_GROUPS
        gid_t     groups[SEC_GROUPS];   /* default supplemental groups  */
#endif
} m6_sec;

#define MAX_IFNAME 24
#define MAX_RHNAME 256

struct m6if {
        m6_sec    tnsec;                /* security structure    */
        char      if_name [MAX_IFNAME]; /* name of the interface */      
};

/* This define is used in libm6 to determine if support for a backward
 * compatibility mode is necessary.
 */

#if (SEC_3_COMPAT || SEC_3_COMPAT_M6) && SEC_MSIX_RCAS_OSI
#define SEC_NEED3COMPAT_M6	1
#endif

/* This is used by the application to determine which of the MaxSix
 * library routines will be used the rel3 or the rel4 versions.
 */
#if !SEC_3_COMPAT_M6
struct m6rh {
        m6_sec    tnsec;                /* security structure */
        char      rh_name [MAX_RHNAME];  /* name of the remote host */      
        mask_t    max_privs[SEC_SPRIVVEC_SIZE];  /* maximum privileges */
        u_long    cache_size;           /* size of cache */
        int       host_type;            /* communication mode */
	int	  smm_type;		/* session management */
	int	  auth_type;		/* authentication */
	int	  encrypt_type;		/* encryption */
	long	  doi;			/* domain of interpretation */
	long	  dot;			/* domain of translation */
#if	SEC_MSIX_RCAS_OSI
	struct m6addrlist hosts;	/* list of hosts sharing this entry */
#else	/* SEC_MSIX_RCAS_OSI */
	struct addrlist  hosts;		/* list of hosts sharing this entry */
#endif	/* SEC_MSIX_RCAS_OSI */
};
#endif
#if SEC_NEED3COMPAT_M6
struct _rel3_m6rh {
        m6_sec    tnsec;                /* security structure */
        char      rh_name [MAX_RHNAME];  /* name of the remote host */      
        mask_t    max_privs[SEC_SPRIVVEC_SIZE];  /* maximum privileges */
        u_long    cache_size;           /* size of cache */
        int       host_type;            /* communication mode */
	int	  smm_type;		/* session management */
	int	  auth_type;		/* authentication */
	int	  encrypt_type;		/* encryption */
	long	  doi;			/* domain of interpretation */
	long	  dot;			/* domain of translation */
	struct addrlist  hosts;		/* list of hosts sharing this entry */
};
#endif

#if SEC_3_COMPAT_M6
#define	m6rh		_rel3_m6rh
#define m6addrtorh	_rel3_m6addrtorh
#define	m6getrhent	_rel3_m6getrhent
#define m6getrhnam	_rel3_m6getrhnam
#define m6putrhent	_rel3_m6putrhent
#define m6delrhent	_rel3_m6delrhent
#define m6getrhaddr	_rel3_m6getrhaddr
#define m6rh_copy	_rel3_m6rh_copy
extern struct _rel3_m6rh	*_rel3_m6getrhent();
extern struct _rel3_m6rh	*_rel3_m6getrhnam();
extern struct _rel3_m6rh	*_rel3_m6getrhhost();
extern struct _rel3_m6rh	*_rel3_m6getrhaddr();
extern struct _rel3_m6rh 	*_rel3_m6addrtorh();
#else
extern struct m6rh	*m6getrhent();
extern struct m6rh	*m6getrhnam();
extern struct m6rh	*m6getrhhost();
extern struct m6rh	*m6getrhaddr();
extern struct m6rh 	*m6addrtorh();
#endif
extern struct m6config	*m6getcfent();
extern struct m6domain	*m6getdoment();
extern struct m6domain	*m6getdomnam();
extern struct m6domain	*m6getdomdoi();
extern struct m6if	*m6getifent();
extern struct m6if	*m6getifnam();
extern struct m6if	*m6if_alloc();
extern struct m6rh	*m6rh_alloc();
extern m6_sec		*tnsec_alloc();
#if	SEC_MSIX_RCAS_OSI
extern struct m6sockaddr	*m6nametoaddr();
extern struct m6sockaddr	*m6_addr();
extern char 		*m6_ntoa();
extern char 		*m6addrtoname();
#endif	/* SEC_MSIX_RCAS_OSI */

extern char	*m6err_string;

#endif /* SEC_MSIX_INET */
#endif  /* __M6DB__ */
